VERSION 5.00
Object = "{4DE9E2A3-150F-11CF-8FBF-444553540000}#4.0#0"; "DlxOCX32.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5955
   ClientLeft      =   2085
   ClientTop       =   1650
   ClientWidth     =   6120
   Icon            =   "frmDIOBuffer.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   5955
   ScaleWidth      =   6120
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Left            =   5280
      Top             =   1320
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   615
      Left            =   4200
      TabIndex        =   9
      Top             =   4920
      Width           =   735
   End
   Begin VB.CommandButton cmdInit 
      Caption         =   "Open and Init Driver"
      Height          =   375
      Left            =   360
      TabIndex        =   8
      Top             =   960
      Width           =   2295
   End
   Begin VB.ComboBox devNum 
      Height          =   315
      Left            =   2880
      TabIndex        =   7
      TabStop         =   0   'False
      Text            =   "0"
      Top             =   960
      Width           =   615
   End
   Begin VB.CommandButton cmdStop 
      Caption         =   "Stop IRQ mode Read"
      Enabled         =   0   'False
      Height          =   375
      Left            =   360
      TabIndex        =   6
      Top             =   3120
      Width           =   2295
   End
   Begin VB.Frame Frame1 
      Caption         =   "Clock Edge Selection"
      Height          =   1215
      Left            =   2880
      TabIndex        =   3
      Top             =   1560
      Width           =   2175
      Begin VB.OptionButton optRising 
         Caption         =   "Rising Edge"
         Height          =   255
         Left            =   240
         TabIndex        =   5
         Top             =   720
         Value           =   -1  'True
         Width           =   1575
      End
      Begin VB.OptionButton optFalling 
         Caption         =   "Falling Edge"
         Height          =   195
         Left            =   240
         TabIndex        =   4
         Top             =   360
         Width           =   1335
      End
   End
   Begin DlsrLib.DriverLINXLDD LDD 
      Left            =   5040
      Top             =   120
      _Version        =   262144
      _ExtentX        =   741
      _ExtentY        =   741
      _StockProps     =   64
      _Version        =   262144
      _ExtentX        =   741
      _ExtentY        =   741
      _StockProps     =   64
   End
   Begin VB.ListBox List1 
      Height          =   1425
      Left            =   3000
      TabIndex        =   2
      Top             =   3120
      Width           =   1695
   End
   Begin VB.CommandButton cmdDIStart 
      Caption         =   "Start IRQ mode Read"
      Enabled         =   0   'False
      Height          =   375
      Left            =   360
      TabIndex        =   1
      Top             =   1800
      Width           =   2295
   End
   Begin DlsrLib.DriverLINXSR SRDI 
      Left            =   5040
      Top             =   720
      _Version        =   262144
      _ExtentX        =   741
      _ExtentY        =   741
      _StockProps     =   64
   End
   Begin VB.Label Label2 
      Caption         =   "Device Number:"
      BeginProperty Font 
         Name            =   "Small Fonts"
         Size            =   6
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   135
      Left            =   2880
      TabIndex        =   11
      Top             =   600
      Width           =   1335
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      BackColor       =   &H000000FF&
      Caption         =   "  KEITHLEY  "
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FFFFFF&
      Height          =   360
      Left            =   480
      TabIndex        =   10
      Top             =   240
      Width           =   1845
   End
   Begin VB.Shape Shape1 
      FillColor       =   &H000000FF&
      FillStyle       =   0  'Solid
      Height          =   255
      Left            =   1080
      Shape           =   3  'Circle
      Top             =   3960
      Width           =   375
   End
   Begin VB.Label lblStatus 
      BackColor       =   &H8000000E&
      Caption         =   "Status"
      Height          =   255
      Left            =   360
      TabIndex        =   0
      Top             =   5040
      Width           =   3735
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
' VB6.0 application
' tested with KPCI-PIO24
' using KPCIPIO-850A04 driver revision in Win2K SP1
'
' the IRQ Enable line (Pin 2) must be pulled low
' apply the TTL IRQ Request signal to Pin 1

Private Sub cmdDIStart_Click()
List1.Clear
' set up paced mode digital input task
' init the DI subsystem
With SRDI
.Req_op = DL_INITIALIZE
.Req_mode = DL_OTHER
.Req_subsystem = DL_DI
.Refresh
End With
With SRDI
.Req_op = DL_START
.Req_mode = DL_INTERRUPT
.Req_subsystem = DL_DI
.Evt_Str_type = DL_COMMAND
.Evt_Stp_type = DL_COMMAND
' timing information
.Evt_Tim_type = DL_RATEEVENT
.Evt_Tim_rateChannel = DL_DEFAULTTIMER  ' Pin 1 of KPCI-PIO24; remember to pull pin 2 low to enable IRQ
' program sensitivity to rising or falling edges
If optFalling.Value = True Then
.Evt_Tim_rateClock = DL_EXTERNALNE
Else
.Evt_Tim_rateClock = DL_EXTERNALPE
End If
.Evt_Tim_rateGate = DL_NOCONNECT
.Evt_Tim_rateMode = DL_RATEGEN
.Evt_Tim_ratePeriod = .DLSecs2Tics(DL_DEFAULTTIMER, 1 / 1000) ' estimate the ext clk rate
' channel and number of samples info
.Sel_buf_N = 10
.Sel_buf_samples = 900
.Sel_buf_notify = DL_NOTIFY  ' send buffer filled messages
.Sel_chan_N = 2              ' only one channel involved in the task
.Sel_chan_format = DL_tNATIVE
.Sel_chan_start = 0          ' start at DI channel 0
.Sel_chan_startGainCode = 0
.Sel_chan_stop = 2           ' stop at DI channel 2
.Sel_chan_stopGainCode = 0
                             ' total of 3 channels
.Sel_chan_simultaneousScan = True  ' scan all channels for each IRQ request
'.Req_op_edit = True
'.Refresh
.Refresh  ' start reading
End With
If SRDI.Res_result = DL_NoErr Then
Shape1.FillColor = vbGreen
lblStatus.Caption = "Buffered Digital Input Started...."
cmdStop.Enabled = True
cmdDIStart.Enabled = False
Timer1.Interval = 100
Timer1.Enabled = True
Else
SRDI.Req_op = DL_MESSAGEBOX
SRDI.Refresh
End If
End Sub



Private Sub cmdExit_Click()
' stop any task that could be active
With SRDI
.Req_op = DL_STOP
.Refresh
End With
' unload the driver
SRDI.Req_DLL_name = ""
LDD.Req_DLL_name = ""
End
End Sub

Private Sub cmdInit_Click()
With SRDI
.Req_DLL_name = "kpcipio$"
.Req_device = devNum.ListIndex  ' devNum from combo box
.Req_op = DL_INITIALIZE
.Req_mode = DL_OTHER
.Req_subsystem = DL_DEVICE
.Refresh
End With
lblStatus.Caption = SRDI.Message
If SRDI.Res_result = DL_NoErr Then
LDD.Req_DLL_name = SRDI.Req_DLL_name
LDD.device = SRDI.Req_device
LDD.Refresh
Form1.Caption = "Externally Clocked Digital Input with Keithley " & LDD.Dev_Model
cmdDIStart.Enabled = True
cmdInit.Enabled = False
Else
SRDI.Req_op = DL_MESSAGEBOX
SRDI.Refresh
End If
Form1.SetFocus  ' set focus back to our form
End Sub

Private Sub cmdStop_Click()
Timer1.Enabled = False
With SRDI
.Req_op = DL_STOP
.Refresh
End With
Shape1.FillColor = vbRed
lblStatus.Caption = "Buffered Digital Input stopped by request....."
cmdStop.Enabled = False
cmdDIStart.Enabled = True
End Sub


Private Sub Form_Load()
' center the form
   With Form1
        ' Center the form on the screen
        .Left = (Screen.Width - .Width) / 2
        .Top = (Screen.Height - .Height) / 2
   End With
' populate combo box with legal device numbers
Dim i As Integer
For i = 0 To 5
devNum.AddItem Str(i), i
Next i
' set it equal to first entry
devNum.ListIndex = 0

End Sub


Private Sub SRDI_BufferFilled(task As Integer, device As Integer, subsystem As Integer, mode As Integer, bufIndex As Integer)
List1.Clear
Dim dummy As Long
Dim DIdata(900) As Byte  ' buffer of 900 points was requested
Dim i As Integer

dummy = SRDI.VBArrayBufferXfer(bufIndex, DIdata, DL_BufferToVBArray)
For i = 0 To 5
'List1.AddItem Hex((DIdata(i) And &HFF))
List1.AddItem "Chan " & Str(i) & " data :  " & Str(DIdata(i))
Next i
'Beep
End Sub

Private Sub SRDI_DataLost(task As Integer, device As Integer, subsystem As Integer, mode As Integer, bufIndex As Long, bufElement As Long)
lblStatus.Caption = "Clock Rate too fast.  Increase size or number of buffers"
End Sub

Private Sub Timer1_Timer()
With SRDI
.Req_op = DL_STATUS
.Res_Sta_typeStatus = DL_IOSTATUS
.Refresh
lblStatus.Caption = "Current Buffer is : " & Str(.Res_IO_currentBuffer)
End With
End Sub
